{ --------------------------- }
{ Friday-13th BBS "Red" Intro }
{ --------------------------- }
CONST
  PalMax = 6;
  MaxVRs = 6;
  RedPAL : ARRAY[1..PalMax] OF Byte = (27,29,28,26,24,22);
  WaitVR : Byte = 0;
  EndMsg : STRING = 'Friday-13th BBS / +359 (0)34 32-000'#13#10+
                    '"Red" Intro, coded by The GodFather'#13#10'$';




{---------------------------------------------------------------------------}
PROCEDURE Logo;       EXTERNAL; {$L LOGO.OBJ   }
PROCEDURE Music_Data; EXTERNAL; {$L MUSIC.OBJ  }
PROCEDURE _HscPlayer; EXTERNAL; {$L HSCOBJ.OBJ }




{---------------------------------------------------------------------------}
PROCEDURE StartMusic(Song:Pointer; Polling,OldIRQ:Boolean); ASSEMBLER;
ASM
   MOV  AH, 0
   MOV  BL, Polling
   MOV  BH, OldIRQ
   CMP  BH, 1
   JE   @Invert
   MOV  BH, 1
   JMP  @GoOn
 @Invert:
   XOR  BH, BH
 @GoOn:
   LES  SI, DWORD PTR Song
   CALL _HscPlayer
END;

PROCEDURE StopMusic; ASSEMBLER;
ASM
  MOV  AH, 2
  CALL _HscPlayer
END;




{---------------------------------------------------------------------------}
PROCEDURE SetVGADAC(Color,Red,Green,Blue:Byte); ASSEMBLER;
ASM
       CLI
       MOV     AL, Color
       MOV     DX, $3C8
       OUT     DX, AL
       MOV     DX, $3C9
       MOV     AL, Red
       OUT     DX, AL
       MOV     AL, Green
       OUT     DX, AL
       MOV     AL, Blue
       OUT     DX, AL
       STI
END;

PROCEDURE SetPal;
VAR I:Byte;
BEGIN
  FOR I := 1 TO 5 DO SetVGADac(I,RedPAL[I],0,0);
  SetVGADac(20,RedPAL[6],0,0);
END;

PROCEDURE RotatePal; ASSEMBLER;
ASM
  PUSH DS
  POP ES
  MOV SI, OFFSET RedPAL
  MOV AL, BYTE PTR DS:SI
  MOV DI, SI
  INC SI
  MOV CX, 5
  REP MOVSB
  MOV SI, OFFSET RedPAL
  ADD SI, 5
  MOV BYTE PTR DS:SI, AL
END;





{---------------------------------------------------------------------------}
PROCEDURE ShowLOGO(VAR InBuf); ASSEMBLER;
ASM
  MOV AX, 0B800h
  MOV ES, AX
  XOR DI, DI
  MOV CX, 16383
  XOR AX, AX
  REP STOSW

  { Move cursor }
  MOV AH, 0Fh
  INT 10h
  MOV AH, 02h
  MOV DL, 0
  MOV DH, 0
  INT 10h
  { Show logo }
  PUSH DS
  MOV DX, 0B800h
  LDS SI, InBuf
  MOV ES, DX
  XOR DI, DI
  MOV CX, 2000
 @L1:
  LODSB
  STOSB
  INC DI
  LOOP @L1
  LDS  SI, InBuf
  MOV  ES, DX
  XOR  DI, DI
  ADD  SI, 2000
  MOV  CX, 2000
 @L2:
  INC  DI
  LODSB
  STOSB
  LOOP @L2
  POP  DS
END;






{---------------------------------------------------------------------------}
BEGIN
  SetPal;
  SetVGADac(7,55,0,0);
  ShowLogo(@Logo^);
  StartMusic(@Music_Data,False,False);
  ASM
 @MainLoop:
   {VRetrace}
   MOV DX, 03DAh
   @1: IN AL, DX; TEST AL,08h;  JZ @1;
   @2: IN AL, DX; TEST AL,08h; JNZ @2;
   {Rotate palette & play song}
   INC  [WaitVR]
   CMP  [WaitVR], MaxVRs
   JNE  @Next
   CALL RotatePal
   CALL SetPal
   MOV  [WaitVR], 0
 @Next:
   {ESC pressed?}
   IN AL, 60h
   CMP AL, 1
   JNE @MainLoop
   {Stop music}
   CALL StopMusic
   {Restore mode}
   MOV AX, 3
   INT 10h
   MOV AH, 9
   MOV DX, OFFSET EndMSG
   INC DX
   INT 21h

   MOV  AX, 040h
   MOV  ES, AX
   MOV  AX, WORD PTR ES:[$1C]
   MOV  WORD PTR ES:[$1A], AX { Clear KBD buffer }

   MOV  AX, WORD PTR ES:[$17]
   AND  AX, 0FBh
   MOV  WORD PTR ES:[$17], AX { Mask CTRL flag }
   STI
 END;
END.